## org.apache.commons.math.stat.descriptive.moment
Class FourthMoment

    java.lang.Object
      org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
          org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
              org.apache.commons.math.stat.descriptive.moment.FirstMoment
                  org.apache.commons.math.stat.descriptive.moment.SecondMoment
                      org.apache.commons.math.stat.descriptive.moment.ThirdMoment
                          org.apache.commons.math.stat.descriptive.moment.FourthMoment

All Implemented Interfaces:
  java.io.Serializable, StorelessUnivariateStatistic, UnivariateStatistic

    public class FourthMoment

extends ThirdMoment
implements java.io.Serializable

Computes a statistic related to the Fourth Central Moment. Specifically, what is computed is the sum of

(x_i - xbar) ^ 4,

where the x_i are the sample observations and xbar is the sample mean.

The following recursive updating formula is used:

Let

- dev = (current obs - previous mean)
- m2 = previous value of `SecondMoment`
- m2 = previous value of `ThirdMoment`
- n = number of observations (including current obs)

Then

new value = old value - 4 * (dev/n) * m3 + 6 * (dev/n)^2 * m2 +
[n^2 - 3 * (n-1)] * dev^4 * (n-1) / n^3

Returns `Double.NaN` if no data values have been added and returns `0` if there is just one value in the data set.

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

Version:
  $Revision: 811685 $ $Date: 2009-09-05 13:36:48 -0400 (Sat, 05 Sep 2009) $
See Also:
  Serialized Form

Field Summary
`protected double` `m4` fourth moment of values that have been added
`private static long` `serialVersionUID` Serializable version identifier

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.ThirdMoment
`m3, nDevSq`

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.SecondMoment
`m2`

Fields inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`dev, m1, n, nDev`

Constructor Summary
`FourthMoment()` Create a FourthMoment instance
`FourthMoment(FourthMoment original)` Copy constructor, creates a new `FourthMoment` identical to the `original`

Method Summary
`void` `clear()` Clears the internal state of the Statistic
`FourthMoment` `copy()` Returns a copy of the statistic with the same internal state.
`static void` `copy(FourthMoment source, FourthMoment dest)` Copies source to dest.
`double` `getResult()` Returns the current value of the Statistic.
`void` `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

Methods inherited from class org.apache.commons.math.stat.descriptive.moment.ThirdMoment
`copy`

Methods inherited from class org.apache.commons.math.stat.descriptive.moment.SecondMoment
`copy`

Methods inherited from class org.apache.commons.math.stat.descriptive.moment.FirstMoment
`copy, getN`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractStorelessUnivariateStatistic
`equals, evaluate, evaluate, hashCode, incrementAll, incrementAll`

Methods inherited from class org.apache.commons.math.stat.descriptive.AbstractUnivariateStatistic
`test, test`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### serialVersionUID

    private static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

### m4

    protected double m4

  fourth moment of values that have been added

Constructor Detail

### FourthMoment

    public FourthMoment()

  Create a FourthMoment instance

### FourthMoment

    public FourthMoment(FourthMoment original)

  Copy constructor, creates a new `FourthMoment` identical to the `original`

  Parameters:
    `original` - the `FourthMoment` instance to copy

Method Detail

### increment

    public void increment(double d)

  Updates the internal state of the statistic to reflect the addition of the new value.

  Specified by:
    `increment` in interface `StorelessUnivariateStatistic`
  Overrides:
    `increment` in class `ThirdMoment`
  Parameters:
    `d` - the new value.

### getResult

    public double getResult()

  Returns the current value of the Statistic.

  Specified by:
    `getResult` in interface `StorelessUnivariateStatistic`
  Overrides:
    `getResult` in class `ThirdMoment`
  Returns:
    value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

### clear

    public void clear()

  Clears the internal state of the Statistic

  Specified by:
    `clear` in interface `StorelessUnivariateStatistic`
  Overrides:
    `clear` in class `ThirdMoment`

### copy

    public FourthMoment copy()

  Returns a copy of the statistic with the same internal state.

  Specified by:
    `copy` in interface `StorelessUnivariateStatistic`
  Specified by:
    `copy` in interface `UnivariateStatistic`
  Overrides:
    `copy` in class `ThirdMoment`
  Returns:
    a copy of the statistic

### copy

    public static void copy(FourthMoment source,
                            FourthMoment dest)

  Copies source to dest.

  Neither source nor dest can be null.

  Parameters:
    `source` - FourthMoment to copy
    `dest` - FourthMoment to copy to
  Throws:
    `java.lang.NullPointerException` - if either source or dest is null

Copyright (c) 2003-2010 Apache Software Foundation